
#    MIDAS Access Server  for  VHSADC server

package require MIDASDomainHandler       ;#  load default support procedures

set z [catch {package require VHSADC} m]
if {$z != 0} {puts "$m"}

global MIDAS_VHSADCAccessServer_Exists
set MIDAS_VHSADCAccessServer_Exists 1

global MIDAS_SOAPDomainHandler_Verbose
set MIDAS_SOAPDomainHandler_Verbose 0

global MIDAS_VHSADCAccessServer_Verbose
set MIDAS_VHSADCAccessServer_Verbose 0

global MIDAS_VHSADC_MaxBoards 
if {![info exists MIDAS_VHSADC_MaxBoards]} {set MIDAS_VHSADC_MaxBoards 8}

global VHSADCAccessServerHost
set VHSADCAccessServerHost "undefined"


# Use namespaces to isolate your methods
namespace eval urn:VHSADCAccessServer {

variable WriteIF 0x70     ;#   User Register 0
variable ReadIF 0x74      ;#   User Register 1

   set rc [catch {
      if {$::LyrTech::TestMode != 0} {
         global R3BData
         set R3BData(0,0,0)  0
      }
   } m]
   
    proc SetUpTemp {} {
        global env

        if {![info exists env(MIDASTempDir)] || ![file exists $env(MIDASTempDir)]} then {
           switch $env(os) {
              Win {set env(MIDASTempDir) [file join c:/ temp]}
              default {set env(MIDASTempDir) /tmp}
           }
        }   

        catch {file mkdir $env(MIDASTempDir}
        catch {file mkdir [file join $env(MIDASTempDir) VHSADCAccessServer]}
    }
    

    proc VHSADCVerbose {vl} {       ;#    via SOAP
 
        set rc [do_VHSADCVerbose $vl]
        return [rpcvar::rpcvar int $rc]
    }
    
    proc VHSADCInit {} {         ;#via SOAP
        global MIDAS_VHSADCAccessServer_Verbose    

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::do_VHSADCInit"}
             
        set rc [do_VHSADCInit] 
        return [rpcvar::rpcvar int $rc]
    }
   
     proc VHSADCExit {} {         ;#via SOAP
    
        set rc [do_VHSADCExit] 
        return [rpcvar::rpcvar int $rc]
    }
    
    proc VHSADCUpLoad {file contents} {
     
        set rc [do_VHSADCUpLoad $file $contents]
        return [rpcvar::rpcvar int $rc]
    }
    
    proc Vhsadac16FpgaReset {id bitstream len} {   ;# via SOAP
    
        set rc [do_vhsadcc16FpgaReset $id $bitstream $len] 
        return [rpcvar::rpcvar int $rc]
    }
    
    proc Vhsadac16FpgaLoad {id bitstream} {
    
        set rc [do_Vhsadac16FpgaLoad $id $bitstream]
        return [rpcvar::rpcvar int $rc]
    }

    proc Vhsadac16FlashErase {id} {
    
        set rc [do_Vhsadac16FlashErase $id]
        return [rpcvar::rpcvar int $rc]
    }
    
    proc Vhsadac16FlashProgram {id bitstream} {
    
        set rc [do_Vhsadac16FlashProgram $id $bitstream]
        return [rpcvar::rpcvar int $rc]
    }
    
    proc Vhsadac16FlashBoot {id} {
    
        set rc [do_Vhsadac16FlashBoot $id]
        return [rpcvar::rpcvar int $rc]
    }
    
     proc Vhsadac16ReadFpgaReg {id register} {
    
        set rc [do_Vhsadac16ReadFpgaReg $id $register]
        return [rpcvar::rpcvar int $rc]
    }
    
     proc Vhsadac16FpgaReadRegs {id registers} {
    
        set rc [do_Vhsadac16FpgaReadRegs $id $registers]
        return [rpcvar::rpcvar int() $rc]
    }
    
    proc  VHSADCReadUserRegs {id registers} {
    
        set rc [do_VHSADCReadUserRegs $id $registers]
        return [rpcvar::rpcvar int() $rc]
    }
    
    proc Vhsadac16WriteFpgaReg {id register value} {
    
        set rc [do_Vhsadac16WriteFpgaReg $id $register $value]
        return [rpcvar::rpcvar int $rc]
    }
    
    proc Vhsadac16WriteFpgaRegs {id arg} {
    
        set rc [do_Vhsadac16WriteFpgaRegs $id $arg]
        return [rpcvar::rpcvar int $rc]
    }
    
    proc VHSADCWriteUserRegs {id registers} {
    
        set rc [do_VHSADCWriteUserRegs $id $registers]
        return [rpcvar::rpcvar int $rc]
    }
    
    proc Vhsadac16GetCpldRegs {id} {
    
        set rc [do_Vhsadac16GetCpldRegs $id]
        return [rpcvar::rpcvar string $rc]
    }
    
    proc do_VHSADCVerbose {vl} {       ;#   internal call
        global MIDAS_VHSADCAccessServer_Verbose MIDAS_SOAPDomainHandler_Verbose

        set MIDAS_VHSADCAccessServer_Verbose $vl
        set MIDAS_SOAPDomainHandler_Verbose $vl 
        
        set rc 0
    }

    proc do_VHSADCInit {} {         ;#   internal call
        global errorCode errorInfo
        global MIDAS_VHSADCAccessServer_Verbose
        global MIDAS_VHSADC_MaxBoards

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::do_VHSADCInit"}
             
        if {$::LyrTech::TestMode != 0} {
            set rc [llength $::LyrTech::crateList]
            
            set z [catch {SetUpTemp} m]
            if {$z != 0}  {puts "VHSADC_Init reply $z  $m"; return -1}
            
            return $rc
        }

        set rc [catch {VHSADC_Init} m]      ;#  see VHSADC.c  (dll)
        if {$rc != 0} {
           InsertLog {"VHSADC_Init returned with an error  rc=$rc\n$m\n$errorCode\n$errorInfo"}
           return -code error -errorcode $errorCode -errorinfo "[first [split $errorInfo \n]]"
        }
           
        if {$rc > $MIDAS_VHSADC_MaxBoards} {set rc $MIDAS_VHSADC_MaxBoards}
        
        set z [catch {SetUpTemp} m]
        if {$z != 0}  {puts "VHSADC_Init reply $z  $m"; return -1}

        return $rc
    }

    proc do_VHSADCUpLoad {file contents} {
        global env MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADC_UpLoad"}

        set path [file join $env(MIDASTempDir) VHSADCServer [file tail $file].base64]

        set z [catch {open $path w} f]
        if {$z != 0} then {error "Cannot create/open file $path in VHSADCUpLoad\n$f"}

        puts $f $contents
        close $f

        set f [file join $env(MIDASTempDir) VHSADCServer [file tail $file]]

        set z [catch {exec base64 --decode $path $f} m]
        if {$z != 0} then {error "Error in base64 decoding $path in VHSADCUpLoad\n$m"}

        set rc 0

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_Vhsadac16FpgaReset {id bitstream len} {
        global env MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FpgaReset"}

        set path [file join $env(MIDASTempDir) VHSADCServer [file tail $bitstream]]

        set rc [Vhsadac16_FpgaReset $id $path $len]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return [rpcvar::rpcvar int $rc]
    }

    proc do_Vhsadac16FpgaLoad {id bitstream} {
        global env MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FpgaLoad"}

        set path [file join $env(MIDASTempDir) VHSADCServer [file tail $bitstream]]

        set rc [Vhsadac16_FpgaLoad $id $path]

        after 2000   ;#  delay helps prevent Windows freeze 

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_Vhsadac16FlashProgram {id bitstream} {
        global env MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FlashProgram"}

        set path [file join $env(MIDASTempDir) VHSADCServer [file tail $bitstream]]

        set rc [Vhsadac16_FlashProgram $id $path]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_Vhsadac16FlashErase {id} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FlashErase"}

        set rc [Vhsadac16_FlashErase $id]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_Vhsadac16FlashBoot {id} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_FlashBoot"}

        set rc [Vhsadac16_FlashBoot $id]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }


    proc do_Vhsadac16ReadFpgaReg {id register} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_ReadFpgaReg"}
             
  if {$::LyrTech::TestMode != 0} {
     global VHSADCData
     if {![info exists VHSADCData($::LyrTech::crateID,$id,$register)]} {set VHSADCData($::LyrTech::crateID,$id,$register) 0xaaaa}
  InsertLog "do_Vhsadac16ReadFpgaReg $::LyrTech::crateID,$id,$register  reads  [set VHSADCData($::LyrTech::crateID,$id,$register)]"
     return [set VHSADCData($::LyrTech::crateID,$id,$register)]
  }

        set rc [Vhsadac16_ReadFpgaReg $id $register]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_Vhsadac16ReadFpgaRegs {id registers} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_ReadFpgaRegs"}

        set rc {}
        foreach register $registers {
            lappend rc [Vhsadac16_ReadFpgaReg $id $register]
        }

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_VHSADCReadUserRegs {id registers} {
        global MIDAS_VHSADCAccessServer_Verbose
        variable ReadIF

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADCReadUserRegs"}
             
  if {$::LyrTech::TestMode != 0} {
     global VHSADCData
     if {![info exists VHSADCData($::LyrTech::crateID,$id,$registers)]} {set VHSADCData($::LyrTech::crateID,$id,$registers) 0xaaaa}
  InsertLog "do_Vhsadac16ReadUserRegs $::LyrTech::crateID,$id,$registers  writes  [set VHSADCData($::LyrTech::crateID,$id,$registers)]"
     return [set VHSADCData($::LyrTech::crateID,$id,$registers)]
  }

        set z [catch {::namespace inscope ::urn:NetVarService WriteRegister NetVar.DACQ.RunControl 1} msg]
        after 10

        set rc {}
        foreach register $registers {

            Vhsadac16_WriteFpgaReg $id $ReadIF $register        ;#    write to user register
            Vhsadac16_WriteFpgaReg $id $ReadIF $register        ;#    write to user register
            lappend rc [Vhsadac16_ReadFpgaReg $id $ReadIF]  ;# user register
        }

        set z [catch {::namespace inscope ::urn:NetVarService WriteRegister NetVar.DACQ.RunControl 0} msg]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_Vhsadac16WriteFpgaReg {id register value} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_WriteFpgaReg"}
             
  if {$::LyrTech::TestMode != 0} {
     global VHSADCData
     if {![info exists VHSADCData($::LyrTech::crateID,$id,$register)]} {set VHSADCData($::LyrTech::crateID,$id,$register)  $value}
  InsertLog "do_Vhsadac16WriteFpgaReg $::LyrTech::crateID,$id,$register  writes  [set VHSADCData($::LyrTech::crateID,$id,$register)]"
     return [set VHSADCData($::LyrTech::crateID,$id,$register)]
  }

        set rc [Vhsadac16_WriteFpgaReg $id $register $value]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_Vhsadac16WriteFpgaRegs {id arg} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_WriteFpgaRegs"}

        foreach item $arg {
          set rc [Vhsadac16_WriteFpgaReg $id [first $item] [second $item]]
#          if {$rc != 0} {break}
        }

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_VHSADCWriteUserRegs {id registers} {
        global MIDAS_VHSADCAccessServer_Verbose
        variable WriteIF

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::VHSADCWriteUserRegs"}
             
  if {$::LyrTech::TestMode != 0} {
     global VHSADCData
     if {![info exists VHSADCData($::LyrTech::crateID,$id,$registers)]} {set VHSADCData($::LyrTech::crateID,$id,$WriteIF)  $registers}
  InsertLog "do_Vhsadac16WriteUserRegs $::LyrTech::crateID,$id,$registers  writes  [set VHSADCData($::LyrTech::crateID,$id,$WriteIF)]"
     return [set VHSADCData($::LyrTech::crateID,$id,$WriteIF)]
  }
  
        set z [catch {::namespace inscope ::urn:NetVarService WriteRegister NetVar.DACQ.RunControl 1} msg]
        after 10

        foreach register $registers {
            set rc [Vhsadac16_WriteFpgaReg $id $WriteIF $register]
#            if {$rc != 0} {break}
        }

        set z [catch {::namespace inscope ::urn:NetVarService WriteRegister NetVar.DACQ.RunControl 0} msg]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_Vhsadac16GetCpldRegs {id} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::Vhsadac16_GetCpldRegs"}
             
  if {$::LyrTech::TestMode != 0} {
     global VHSADCData
     if {![info exists VHSADCData($::LyrTech::crateID,$id,"cpld")]} {set VHSADCData($::LyrTech::crateID,$id,"cpld") "0xaaaa 0xaaaa 0xaaaa 0xaaaa 0xaaaa 0xaaaa"}
  InsertLog "do_Vhsadac16GetCpldRegs $::LyrTech::crateID,$id  reads  [set VHSADCData($::LyrTech::crateID,$id,"cpld")]"
     return [set VHSADCData($::LyrTech::crateID,$id,"cpld")]
  }

        set rc [Vhsadac16_GetCpldRegs $id]

        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }

    proc do_VHSADCExit {} {
        global MIDAS_VHSADCAccessServer_Verbose

        if {$MIDAS_VHSADCAccessServer_Verbose} \
             {puts "called method VHSADC::ServerExit"}

   set rc 0
             
        if {$MIDAS_VHSADCAccessServer_Verbose}  {puts "VHSADC reply $rc"}

        return $rc
    }


    # We have to publish the public methods...

     SOAP::export VHSADCVerbose
     SOAP::export VHSADCInit

     SOAP::export VHSADCUpLoad

     SOAP::export Vhsadac16FpgaReset
     SOAP::export Vhsadac16FpgaLoad

     SOAP::export Vhsadac16FlashProgram
     SOAP::export Vhsadac16FlashErase
     SOAP::export Vhsadac16FlashBoot

     SOAP::export Vhsadac16ReadFpgaReg
     SOAP::export Vhsadac16WriteFpgaReg

     SOAP::export Vhsadac16ReadFpgaRegs
     SOAP::export Vhsadac16WriteFpgaRegs
     
     SOAP::export VHSADCReadUserRegs
     SOAP::export VHSADCWriteUserRegs

     SOAP::export Vhsadac16GetCpldRegs

     SOAP::export VHSADCExit
     
} 

# register this service with tclhttpd
puts "[SOAP::Domain::register  -prefix  /VHSADCAccessServer -namespace urn:VHSADCAccessServer -uri urn:VHSADCAccessServer]"


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/VHSADCAccessServer {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}

package provide VHSADCAccessServer 1.0

set msg "$rc Web Service Installed\n"

   if {[info procs ::DefineMessage] != "::DefineMessage"} {puts "DefineMessage unknown"} else {
       ::DefineMessage -c vhsadc -l INFORMATION  "$msg"}
       
       
       
       
       
